## mariadb-10.6 10.6.7

=== scripts/CMakeLists.txt ===
# Copyright (c) 2006, 2017, Oracle and/or its affiliates.
# Copyright (c) 2011, 2020, MariaDB Corporation
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1335 USA

# Build comp_sql - used for embedding SQL in C or C++ programs

MACRO(INSTALL_LINK old new destination component)
  EXECUTE_PROCESS(
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${old} ${new}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  )
  INSTALL(
    PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${new}
    DESTINATION ${destination}
    COMPONENT ${component}
  )
ENDMACRO()

IF(NOT CMAKE_CROSSCOMPILING OR DEFINED CMAKE_CROSSCOMPILING_EMULATOR)
 INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include)
 ADD_EXECUTABLE(comp_sql comp_sql.c ../sql/sql_bootstrap.cc)
 TARGET_LINK_LIBRARIES(comp_sql)
ENDIF()

# Build mysql_fix_privilege_tables.sql (concatenate 3 sql scripts)
IF(NOT WIN32 OR  (CMAKE_CROSSCOMPILING AND NOT DEFINED CMAKE_CROSSCOMPILING_EMULATOR))
  FIND_PROGRAM(CAT_EXECUTABLE cat DOC "path to the executable")
  MARK_AS_ADVANCED(CAT_EXECUTABLE)
ENDIF()

IF(NOT ("${CMAKE_BINARY_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}"))
  FOREACH(f fill_help_tables.sql mysql_system_tables_fix.sql mysql_system_tables.sql mysql_system_tables_data.sql mysql_performance_tables.sql)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${f} ${CMAKE_CURRENT_BINARY_DIR}/${f} COPYONLY)
  ENDFOREACH()
ENDIF()

IF(CAT_EXECUTABLE)
  SET(CAT_COMMAND COMMAND
    ${CAT_EXECUTABLE} mysql_system_tables_fix.sql mysql_system_tables.sql mysql_performance_tables.sql mysql_sys_schema.sql>
    mysql_fix_privilege_tables.sql
  )
ELSEIF(WIN32)
  SET(CAT_COMMAND
   COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_CURRENT_BINARY_DIR}
   cmd /c copy /b mysql_system_tables_fix.sql + mysql_system_tables.sql +  mysql_performance_tables.sql + mysql_sys_schema.sql
   mysql_fix_privilege_tables.sql )
ELSE()
  MESSAGE(FATAL_ERROR "Cannot concatenate files")
ENDIF()

# Build mysql_fix_privilege_tables.c
ADD_CUSTOM_COMMAND(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/mysql_fix_privilege_tables_sql.c
  ${CAT_COMMAND}
  COMMAND comp_sql
  mysql_fix_privilege_tables
  mysql_fix_privilege_tables.sql
  mysql_fix_privilege_tables_sql.c
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS comp_sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_tables.sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_tables_fix.sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_performance_tables.sql
  ${CMAKE_CURRENT_BINARY_DIR}/mysql_sys_schema.sql
)

# Add target for the above to be built
ADD_CUSTOM_TARGET(GenFixPrivs
  ALL
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/mysql_fix_privilege_tables_sql.c
)

IF(UNIX AND NOT WITHOUT_SERVER)
 FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/make_binary_distribution
   "cd ${CMAKE_BINARY_DIR} && '${CMAKE_CPACK_COMMAND}' -G TGZ --config CPackConfig.cmake\n" )
 EXECUTE_PROCESS(
  COMMAND chmod +x ${CMAKE_CURRENT_BINARY_DIR}/make_binary_distribution
)
ENDIF()

# Configure two scripts from one 'in' file.
# The maria_add_gis_sp.sql - to be sent to 'mysql' tool
# and the maria_add_gis_sp_bootstrap.sql, that can be sent to
# the server as a bootstrap command.

SET(ADD_GIS_SP_SET_DELIMITER "delimiter |")
SET(ADD_GIS_SP_RESET_DELIMITER "delimiter ;")
SET(ADD_GIS_SP_EOL "|")
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/maria_add_gis_sp.sql.in
  ${CMAKE_CURRENT_BINARY_DIR}/maria_add_gis_sp.sql ESCAPE_QUOTES @ONLY)

SET(ADD_GIS_SP_SET_DELIMITER "")
SET(ADD_GIS_SP_RESET_DELIMITER "")
SET(ADD_GIS_SP_EOL ";")
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/maria_add_gis_sp.sql.in
  ${CMAKE_CURRENT_BINARY_DIR}/maria_add_gis_sp_bootstrap.sql ESCAPE_QUOTES @ONLY)

IF (NOT WITHOUT_SERVER)
INSTALL(FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_tables.sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_system_tables_data.sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_performance_tables.sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_test_db.sql
  ${CMAKE_CURRENT_SOURCE_DIR}/fill_help_tables.sql
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql_test_data_timezone.sql
  ${CMAKE_CURRENT_BINARY_DIR}/maria_add_gis_sp.sql
  ${CMAKE_CURRENT_BINARY_DIR}/maria_add_gis_sp_bootstrap.sql
  ${CMAKE_CURRENT_BINARY_DIR}/mysql_sys_schema.sql
  ${FIX_PRIVILEGES_SQL}
  DESTINATION ${INSTALL_MYSQLSHAREDIR} COMPONENT Server
)
ENDIF()

# TCMalloc hacks
IF(MALLOC_LIB)
  MESSAGE("Using tcmalloc '${MALLOC_LIB}'")
  INSTALL(FILES ${MALLOC_LIB} DESTINATION ${INSTALL_LIBDIR} OPTIONAL)
ENDIF()

IF(CMAKE_GENERATOR MATCHES "Makefiles|Ninja")
  FOREACH(ARCH ${CMAKE_OSX_ARCHITECTURES})
    SET(CFLAGS   "${CFLAGS} -arch ${ARCH}")
    SET(CXXFLAGS "${CXXFLAGS} -arch ${ARCH}")
  ENDFOREACH()
ENDIF()

IF(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  SET (PERL_PATH "/usr/local/bin/perl")
ELSE()
  SET (PERL_PATH "/usr/bin/perl")
ENDIF()

IF(UNIX)
  # FIND_PROC and CHECK_PID are used by mysqld_safe
IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
  SET (FIND_PROC
    "ps wwwp $PID | grep -vE mariadbd-safe -vE mysqld_safe | grep -- $MYSQLD > /dev/null")
ENDIF()
IF(NOT FIND_PROC AND CMAKE_SYSTEM_NAME MATCHES "SunOS")
  SET (FIND_PROC
    "ps -p $PID | grep -v mariadbd-safe | grep -- $MYSQLD > /dev/null")
ENDIF()

IF(NOT FIND_PROC)
  # BSD style
  EXECUTE_PROCESS(COMMAND ps -uaxww OUTPUT_QUIET ERROR_QUIET RESULT_VARIABLE result)
  IF(result MATCHES 0)
     SET( FIND_PROC
       "ps -uaxww | grep -v mariadbd-safe | grep -- $MYSQLD | grep $PID > /dev/null")
  ENDIF()
ENDIF()

IF(NOT FIND_PROC)
  # SysV style
  EXECUTE_PROCESS(COMMAND ps -ef OUTPUT_QUIET ERROR_QUIET RESULT_VARIABLE result)
  IF(result MATCHES 0)
    SET( FIND_PROC "ps -ef | grep -v mariadbd-safe | grep -- $MYSQLD | grep $PID > /dev/null")
  ENDIF()
ENDIF()

EXECUTE_PROCESS(COMMAND sh -c "kill -0 $$" OUTPUT_QUIET ERROR_QUIET RESULT_VARIABLE result)
IF(result MATCHES 0)
  SET(CHECK_PID "kill -0 $PID > /dev/null 2> /dev/null")
ELSE()
  SET(CHECK_PID "kill -s SIGCONT $PID  > /dev/null 2> /dev/null")
ENDIF()

SET(HOSTNAME "uname -n")
SET(MYSQLD_USER "mysql")
SET(MYSQLD_GROUP "mysql")
ENDIF(UNIX)

# Really ugly, one script, "mysql_install_db", needs prefix set to ".",
# i.e. makes access relative the current directory. This matches
# the documentation, so better not change this.

IF(INSTALL_LAYOUT MATCHES "STANDALONE")
  SET(prefix ".")
  SET(bindir ${prefix}/${INSTALL_BINDIR})
  SET(sbindir ${prefix}/${INSTALL_SBINDIR})
  SET(scriptdir ${prefix}/${INSTALL_BINDIR})
  SET(libexecdir ${prefix}/${INSTALL_SBINDIR})
  SET(pkgdatadir ${prefix}/${INSTALL_MYSQLSHAREDIR})
  SET(pkgplugindir ${prefix}/${INSTALL_PLUGINDIR})
  SET(localstatedir ${prefix}/data)
ELSE()
  SET(prefix "${CMAKE_INSTALL_PREFIX}")
  SET(bindir ${INSTALL_BINDIRABS})
  SET(sbindir ${INSTALL_SBINDIRABS})
  SET(scriptdir ${INSTALL_BINDIRABS})
  SET(libexecdir ${INSTALL_SBINDIRABS})
  SET(pkgdatadir ${INSTALL_MYSQLSHAREDIRABS})
  SET(pkgplugindir ${INSTALL_PLUGINDIRABS})
  SET(localstatedir ${MYSQL_DATADIR})
ENDIF()

SET(resolveip_locations "$basedir/${INSTALL_BINDIR} $basedir/bin")
SET(mysqld_locations "$basedir/${INSTALL_SBINDIR} $basedir/libexec $basedir/sbin $basedir/bin")
SET(errmsg_locations "$basedir/${INSTALL_MYSQLSHAREDIR}/english $basedir/share/english $basedir/share/mysql/english")
SET(pkgdata_locations "$basedir/${INSTALL_MYSQLSHAREDIR} $basedir/share $basedir/share/mysql")

# install mysql_install_db.sh at this point since it needs
# different values for the above variables that will change
# afterwards
IF(UNIX AND NOT WITHOUT_SERVER)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/mysql_install_db.sh
    ${CMAKE_CURRENT_BINARY_DIR}/mariadb-install-db ESCAPE_QUOTES @ONLY)
  EXECUTE_PROCESS(COMMAND chmod +x ${CMAKE_CURRENT_BINARY_DIR}/mariadb-install-db)
  INSTALL_SCRIPT(
    "${CMAKE_CURRENT_BINARY_DIR}/mariadb-install-db"
    DESTINATION ${INSTALL_SCRIPTDIR}
    COMPONENT Server)

  INSTALL_LINK(mariadb-install-db mysql_install_db ${INSTALL_SCRIPTDIR} Server)
ENDIF()

SET(prefix "${CMAKE_INSTALL_PREFIX}")
IF(INSTALL_SYSCONFDIR)
  SET(sysconfdir ${DEFAULT_SYSCONFDIR})
ELSE()
  SET(sysconfdir "/etc")
ENDIF()
SET(bindir ${INSTALL_BINDIRABS})
SET(libexecdir ${INSTALL_SBINDIRABS})
SET(scriptdir ${INSTALL_BINDIRABS})
SET(datadir ${INSTALL_MYSQLSHAREDIRABS})
SET(pkgdatadir ${INSTALL_MYSQLSHAREDIRABS})
SET(libsubdir  ${INSTALL_LIBDIR})
SET(pkgincludedir ${INSTALL_INCLUDEDIRABS})
SET(pkglibdir ${INSTALL_LIBDIRABS})
SET(pkgplugindir ${INSTALL_PLUGINDIRABS})
SET(localstatedir ${MYSQL_DATADIR})

SET(RPATH_OPTION "")
IF(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
  SET(RPATH_OPTION "-R$pkglibdir")
ENDIF()

# some scripts use  @TARGET_LINUX@
IF(CMAKE_SYSTEM_NAME MATCHES "Linux")
  SET(TARGET_LINUX "true")
ELSE()
  SET(TARGET_LINUX "false")
ENDIF()

SET(mysql_config_COMPONENT Development)
SET(msql2mysql_COMPONENT Client)
SET(mariadb-access_COMPONENT Client)
SET(mariadb-find-rows_COMPONENT Client)
SET(mytop_COMPONENT Client)
SET(mariadb-hotcopy_COMPONENT COMPONENT Client)
SET(mariadb-convert-table-format_COMPONENT COMPONENT Client)
SET(mariadb-setpermission_COMPONENT COMPONENT Client)
SET(mariadb-secure-installation_COMPONENT COMPONENT Client)
SET(mariadb-dumpslow_COMPONENT COMPONENT Client)

IF(WIN32)
  # On Windows, some .sh and some .pl.in files are configured
  # The resulting files will have .pl extension (those are perl scripts)

  # Input files with pl.in extension
  SET(PLIN_FILES mysql_config)
  # Input files with .sh extension

  SET(SH_FILES mysql_convert_table_format mysqld_multi mysqldumpslow
    mysqlhotcopy)

  FOREACH(file ${PLIN_FILES})
    IF(NOT ${file}_COMPONENT)
      SET(${file}_COMPONENT Server_Scripts)
    ENDIF()
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${file}.pl.in
      ${CMAKE_CURRENT_BINARY_DIR}/${file}.pl ESCAPE_QUOTES @ONLY)
    INSTALL_SCRIPT(${CMAKE_CURRENT_BINARY_DIR}/${file}.pl COMPONENT ${${file}_COMPONENT})
  ENDFOREACH()

  FOREACH(file ${SH_FILES})
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${file}.sh
       ${CMAKE_CURRENT_BINARY_DIR}/${file}.pl ESCAPE_QUOTES @ONLY)
    INSTALL_SCRIPT(${CMAKE_CURRENT_BINARY_DIR}/${file}.pl COMPONENT Server_Scripts)
  ENDFOREACH()
ELSE()
  IF(WITH_WSREP)
    SET(WSREP_SCRIPTS
      wsrep_sst_mysqldump
      wsrep_sst_rsync
      wsrep_sst_mariabackup
    )
    # The following script is sourced from other SST scripts, so it should
    # not be made executable.
    SET(WSREP_SOURCE
      wsrep_sst_common
    )

    INSTALL_LINK(wsrep_sst_rsync wsrep_sst_rsync_wan ${INSTALL_BINDIR} Server)
    FOREACH(file ${WSREP_SOURCE})
      CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${file}.sh
        ${CMAKE_CURRENT_BINARY_DIR}/${file} ESCAPE_QUOTES @ONLY)
      IF(NOT ${file}_COMPONENT)
        SET(${file}_COMPONENT Server)
      ENDIF()
      INSTALL(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/${file}
        DESTINATION ${INSTALL_BINDIR}
        COMPONENT ${${file}_COMPONENT}
      )
    ENDFOREACH()
  ENDIF()
  IF (NOT WITHOUT_SERVER)
    SET(SERVER_SCRIPTS
      mariadb-fix-extensions
      mariadbd-multi
      mariadbd-safe
      ${SYSTEMD_SCRIPTS}
    )
  ENDIF()
  # Configure this one, for testing, but do not install it.
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/mysql_config.pl.in
    ${CMAKE_CURRENT_BINARY_DIR}/mysql_config.pl ESCAPE_QUOTES @ONLY)
  # On Unix, most of the files end up in the bin directory
  SET(BIN_SCRIPTS
    msql2mysql
    mariadb-setpermission
    mariadb-secure-installation
    mariadb-access
    mariadb-convert-table-format
    mariadb-find-rows
    mariadb-dumpslow
    mysql_config
    mytop
    mariadb-hotcopy

=== wsrep-lib/CMakeLists.txt ===
#
# Copyright (C) 2021 Codership Oy <info@codership.com>
#

cmake_minimum_required (VERSION 2.8)

# Parse version from version header file and store it into
# WSREP_LIB_VERSION.
file (READ "include/wsrep/version.hpp" ver)
string(REGEX MATCH "WSREP_LIB_VERSION_MAJOR ([0-9]*)" _ ${ver})
set(ver_major ${CMAKE_MATCH_1})
file (READ "include/wsrep/version.hpp" ver)
string(REGEX MATCH "WSREP_LIB_VERSION_MINOR ([0-9]*)" _ ${ver})
set(ver_minor ${CMAKE_MATCH_1})
file (READ "include/wsrep/version.hpp" ver)
string(REGEX MATCH "WSREP_LIB_VERSION_PATCH ([0-9]*)" _ ${ver})
set(ver_patch ${CMAKE_MATCH_1})
set(WSREP_LIB_VERSION "${ver_major}.${ver_minor}.${ver_patch}")
message(STATUS "Wsrep-lib version: ${WSREP_LIB_VERSION}")

if (POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
  project(wsrep-lib VERSION ${WSREP_LIB_VERSION})
else()
  project(wsrep-lib)
endif()

if (POLICY CMP0057)
  cmake_policy(SET CMP0057 NEW)
endif()

if (POLICY CMP0077)
  cmake_policy(SET CMP0077 NEW)
endif()

include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(CheckCXXCompilerFlag)

# Options

# Compile unit tests
option(WSREP_LIB_WITH_UNIT_TESTS "Compile unit tests" ON)
if (WSREP_LIB_WITH_UNIT_TESTS)
  # Run tests automatically by default if compiled
  option(WSREP_LIB_WITH_AUTO_TEST "Run unit tests automatically after build" OFF)
  option(WSREP_LIB_WITH_UNIT_TESTS_EXTRA "Compile unit tests that may require additional software" OFF)
endif()

# Build a sample program
option(WSREP_LIB_WITH_DBSIM "Compile sample dbsim program" ON)

option(WSREP_LIB_WITH_ASAN "Enable address sanitizer" OFF)
option(WSREP_LIB_WITH_TSAN "Enable thread sanitizer" OFF)

option(WSREP_LIB_WITH_DOCUMENTATION "Generate documentation" OFF)
option(WSREP_LIB_WITH_COVERAGE "Compile with coverage instrumentation" OFF)

option(WSREP_LIB_STRICT_BUILD_FLAGS "Compile with strict build flags" OFF)
option(WSREP_LIB_MAINTAINER_MODE "Fail compilation on any warnings" OFF)

# Compiler options

# Set std to C++0x/C++11 if superproject has not set standard yet
if (NOT CMAKE_CXX_STANDARD OR CMAKE_CXX_STANDARD LESS 11)
  string(FIND "${CMAKE_CXX_FLAGS}" "-std=" HAVE_STD)
  if (HAVE_STD EQUAL -1)
    if (CMAKE_VERSION VERSION_LESS "3.1")
      if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND
          CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8.1)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
      else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
      endif()
    else()
      set(CMAKE_CXX_STANDARD 11)
    endif()
  endif()
endif()

# C flags
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wconversion")
# CXX flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Woverloaded-virtual -Wconversion -g")
check_cxx_compiler_flag("-Wsuggest-override" HAVE_SUGGEST_OVERRIDE)
if (HAVE_SUGGEST_OVERRIDE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-override")
endif()

if (WSREP_LIB_STRICT_BUILD_FLAGS)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Weffc++")
endif()
if (WSREP_LIB_MAINTAINER_MODE)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

# Enable extra libstdc++ assertions with debug build.
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_definitions("-D_GLIBCXX_ASSERTIONS")
else()
  # Make sure that NDEBUG is enabled in release builds even
  # if the parent project does not define it.
  add_definitions("-DNDEBUG")
endif()

# Set up include directories
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/wsrep-API")

# Find libraries.
CHECK_LIBRARY_EXISTS(dl dlopen "" WSREP_LIB_HAVE_LIBDL)
if (WSREP_LIB_HAVE_LIBDL)
  set(WSREP_LIB_LIBDL "dl")
else()
  set(WSREP_LIB_LIBDL "")
endif()

set(MIN_BOOST_VERSION "1.54.0")
if (WSREP_LIB_WITH_UNIT_TESTS)
  if (WSREP_LIB_WITH_UNIT_TESTS_EXTRA)
    set(json_HEADER "boost/json/src.hpp")
    # Extra tests may require packages from very recent boost which may be
    # unavailable on the system. In such case download private boost distro.
    check_include_file_cxx(${json_HEADER} system_json_FOUND)
    if (NOT system_json_FOUND)
      if (NOT WITH_BOOST)
        set(WITH_BOOST "${CMAKE_SOURCE_DIR}/../boost")
      endif()
      set(DOWNLOAD_BOOST ON)
      include (cmake/boost.cmake)
      set(MIN_BOOST_VERSION "${BOOST_MAJOR}.${BOOST_MINOR}.${BOOST_PATCH}")
      message(STATUS "Boost includes: ${BOOST_INCLUDE_DIR}, ver: ${MIN_BOOST_VERSION}")
      find_package(Boost ${MIN_BOOST_VERSION} REQUIRED
        COMPONENTS json headers
        PATHS ${WITH_BOOST}/lib/cmake
        NO_DEFAULT_PATH
        )
      # Boost 1.76.0 comes very sloppy (and not only in JSON department)
      # - need to disable some checks.
      set(ADDITIONAL_CXX_FLAGS "-Wno-effc++ -Wno-conversion -Wno-suggest-override -Wno-overloaded-virtual")
      set(ADDITIONAL_CXX_INCLUDES ${BOOST_INCLUDE_DIR})
      check_include_file_cxx(${json_HEADER} json_FOUND
        "-I${ADDITIONAL_CXX_INCLUDES} ${ADDITIONAL_CXX_FLAGS}"
        )
      if (NOT json_FOUND)
        message(FATAL_ERROR "Required header 'boost/json.hpp' not found: ${json_FOUND}")
      else()
        include_directories(SYSTEM ${ADDITIONAL_CXX_INCLUDES})
      endif()
    endif()
  endif()
  find_package(Boost ${MIN_BOOST_VERSION} REQUIRED
    unit_test_framework
    )
endif()

if (WSREP_LIB_WITH_DBSIM)
  find_package(Boost ${MIN_BOOST_VERSION} REQUIRED
    program_options
    filesystem
    thread
    )
endif()

if (WSREP_LIB_WITH_ASAN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
endif()
if (WSREP_LIB_WITH_TSAN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread")
endif()

# Coverage
#
# To produce a coverage report, call cmake with -DWITH_COVERAGE=ON,
# run
#
#   make
#   make test
#   make coverage_report
#
# The coverage report output will be in directory coverage_report/index.html
#
if (WSREP_LIB_WITH_COVERAGE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
endif()

add_custom_target(coverage_report
  lcov --base-directory ${CMAKE_CURRENT_SOURCE_DIR} --capture --directory ${CMAKE_CURRENT_BINARY_DIR} --output lcov.info --no-external --quiet
  COMMAND genhtml --output-directory coverage_report lcov.info)


if (WSREP_LIB_WITH_DOCUMENTATION)
  find_package(Doxygen REQUIRED)
  add_custom_target(doc ALL
    COMMAND doxygen ${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doc
    COMMENT "Generating documentation with Doxygen"
    VERBATIM)
endif()

add_subdirectory(src)
add_subdirectory(wsrep-API)
if (WSREP_LIB_WITH_UNIT_TESTS)
  enable_testing()
  add_subdirectory(test)
endif()
if (WSREP_LIB_WITH_DBSIM)
  add_subdirectory(dbsim)
endif()

=== extra/wolfssl/wolfssl/IDE/MQX/Makefile ===
WOLF_ROOT = ../..
MQX_ROOT = $(WOLF_ROOT)/../../../Freescale/Freescale_MQX_4_1/
CC       = arm-none-eabi-gcc
AR		 = arm-none-eabi-ar

WOLFLIB  = ./libwolfssl.a
MQXLIB   =

OPTIMIZE = -O2

WORNING  = \
 -Wno-int-to-pointer-cast\
 -Wno-incompatible-pointer-types\
 -Wno-discarded-qualifiers\
 -Wno-int-conversion\
 -Wno-implicit-function-declaration\
 -Wno-pointer-to-int-cast

USER_SETTINGS_H = -I./ -DWOLFSSL_USER_SETTINGS
CFLAGS   = $(OPTIMIZE) -I$(WOLF_ROOT)/. $(USER_SETTINGS_H) $(MQX_INCLUDE) $(WORNING)

MQX_INCLUDE = -I$(MQX_ROOT)/mqx/source/include\
-I$(MQX_ROOT)/mqx/source/psp/cortex_m\
-I$(MQX_ROOT)/mqx/source/psp/cortex_a/compiler/gcc_arm\
-I$(MQX_ROOT)/mqx/source/psp/cortex_m/cpu\
-I$(MQX_ROOT)/mfs/source/include\
-I$(MQX_ROOT)/mqx/source/bsp/twrk70f120m\
-I$(MQX_ROOT)/mqx/source/io/cm\
-I$(MQX_ROOT)/mqx/source/io/lpm\
-I$(MQX_ROOT)/mqx/source/io/serial\
-I$(MQX_ROOT)/mqx/source/io/dma\
-I$(MQX_ROOT)/mqx/source/io/spi\
-I$(MQX_ROOT)/mqx/source/io/i2c\
-I$(MQX_ROOT)/mqx/source/io/io_mem\
-I$(MQX_ROOT)/mqx/source/io/io_null\
-I$(MQX_ROOT)/mqx/source/io/enet\
-I$(MQX_ROOT)/mqx/source/io/enet/macnet\
-I$(MQX_ROOT)/mqx/source/io/lwgpio\
-I$(MQX_ROOT)/mqx/source/io/gpio\
-I$(MQX_ROOT)/mqx/source/io/gpio/kgpio\
-I$(MQX_ROOT)/mqx/source/io/esdhc\
-I$(MQX_ROOT)/mqx/source/io/sdcard\
-I$(MQX_ROOT)/mqx/source/io/sdcard/sdcard_spi\
-I$(MQX_ROOT)/mqx/source/io/sdcard/sdcard_esdhc\
-I$(MQX_ROOT)/mqx/source/io/pccard\
-I$(MQX_ROOT)/mqx/source/io/pcflash\
-I$(MQX_ROOT)/mqx/source/io/adc/kadc\
-I$(MQX_ROOT)/mqx/source/io/adc\
-I$(MQX_ROOT)/mqx/source/io/lwadc\
-I$(MQX_ROOT)/mqx/source/io/flashx\
-I$(MQX_ROOT)/mqx/source/io/flashx/freescale\
-I$(MQX_ROOT)/mqx/source/io/hwtimer\
-I$(MQX_ROOT)/mqx/source/io/rtc\
-I$(MQX_ROOT)/mqx/source/io/debug\
-I$(MQX_ROOT)/mqx/source/io/tchres\
-I$(MQX_ROOT)/mqx/source/io/nandflash\
-I$(MQX_ROOT)/mqx/source/io/timer\
-I$(MQX_ROOT)/mqx/source/io/usb\
-I$(MQX_ROOT)/mqx/source/io/hmi\
-I$(MQX_ROOT)/mqx/source/io/sai\
-I$(MQX_ROOT)/mqx/source/io/rtcs\
-I$(MQX_ROOT)/rtcs/source/include

OBJ =\
$(WOLF_ROOT)/src/crl.o\
$(WOLF_ROOT)/src/internal.o\
$(WOLF_ROOT)/src/keys.o\
$(WOLF_ROOT)/src/ocsp.o\
$(WOLF_ROOT)/src/sniffer.o\
$(WOLF_ROOT)/src/ssl.o\
$(WOLF_ROOT)/src/tls13.o\
$(WOLF_ROOT)/src/tls.o\
$(WOLF_ROOT)/src/wolfio.o\
$(WOLF_ROOT)/wolfcrypt/src/aes.o\
$(WOLF_ROOT)/wolfcrypt/src/arc4.o\
$(WOLF_ROOT)/wolfcrypt/src/asm.o\
$(WOLF_ROOT)/wolfcrypt/src/asn.o\
$(WOLF_ROOT)/wolfcrypt/src/blake2b.o\
$(WOLF_ROOT)/wolfcrypt/src/blake2s.o\
$(WOLF_ROOT)/wolfcrypt/src/camellia.o\
$(WOLF_ROOT)/wolfcrypt/src/chacha20_poly1305.o\
$(WOLF_ROOT)/wolfcrypt/src/chacha.o\
$(WOLF_ROOT)/wolfcrypt/src/cmac.o\
$(WOLF_ROOT)/wolfcrypt/src/coding.o\
$(WOLF_ROOT)/wolfcrypt/src/compress.o\
$(WOLF_ROOT)/wolfcrypt/src/cpuid.o\
$(WOLF_ROOT)/wolfcrypt/src/cryptocb.o\
$(WOLF_ROOT)/wolfcrypt/src/curve25519.o\
$(WOLF_ROOT)/wolfcrypt/src/des3.o\
$(WOLF_ROOT)/wolfcrypt/src/dh.o\
$(WOLF_ROOT)/wolfcrypt/src/dsa.o\
$(WOLF_ROOT)/wolfcrypt/src/ecc.o\
$(WOLF_ROOT)/wolfcrypt/src/ecc_fp.o\
$(WOLF_ROOT)/wolfcrypt/src/ed25519.o\
$(WOLF_ROOT)/wolfcrypt/src/error.o\
$(WOLF_ROOT)/wolfcrypt/src/fe_low_mem.o\
$(WOLF_ROOT)/wolfcrypt/src/fe_operations.o\
$(WOLF_ROOT)/wolfcrypt/src/ge_low_mem.o\
$(WOLF_ROOT)/wolfcrypt/src/ge_operations.o\
$(WOLF_ROOT)/wolfcrypt/src/hash.o\
$(WOLF_ROOT)/wolfcrypt/src/hc128.o\
$(WOLF_ROOT)/wolfcrypt/src/hmac.o\
$(WOLF_ROOT)/wolfcrypt/src/idea.o\
$(WOLF_ROOT)/wolfcrypt/src/integer.o\
$(WOLF_ROOT)/wolfcrypt/src/logging.o\
$(WOLF_ROOT)/wolfcrypt/src/md2.o\
$(WOLF_ROOT)/wolfcrypt/src/md4.o\
$(WOLF_ROOT)/wolfcrypt/src/md5.o\
$(WOLF_ROOT)/wolfcrypt/src/memory.o\
$(WOLF_ROOT)/wolfcrypt/src/pkcs12.o\
$(WOLF_ROOT)/wolfcrypt/src/pkcs7.o\
$(WOLF_ROOT)/wolfcrypt/src/poly1305.o\
$(WOLF_ROOT)/wolfcrypt/src/pwdbased.o\
$(WOLF_ROOT)/wolfcrypt/src/rabbit.o\
$(WOLF_ROOT)/wolfcrypt/src/random.o\
$(WOLF_ROOT)/wolfcrypt/src/ripemd.o\
$(WOLF_ROOT)/wolfcrypt/src/rsa.o\
$(WOLF_ROOT)/wolfcrypt/src/sha256.o\
$(WOLF_ROOT)/wolfcrypt/src/sha3.o\
$(WOLF_ROOT)/wolfcrypt/src/sha512.o\
$(WOLF_ROOT)/wolfcrypt/src/sha.o\
$(WOLF_ROOT)/wolfcrypt/src/signature.o\
$(WOLF_ROOT)/wolfcrypt/src/sp_arm32.o\
$(WOLF_ROOT)/wolfcrypt/src/sp_arm64.o\
$(WOLF_ROOT)/wolfcrypt/src/sp_armthumb.o\
$(WOLF_ROOT)/wolfcrypt/src/sp_c32.o\
$(WOLF_ROOT)/wolfcrypt/src/sp_c64.o\
$(WOLF_ROOT)/wolfcrypt/src/sp_cortexm.o\
$(WOLF_ROOT)/wolfcrypt/src/sp_int.o\
$(WOLF_ROOT)/wolfcrypt/src/sp_x86_64.o\
$(WOLF_ROOT)/wolfcrypt/src/srp.o\
$(WOLF_ROOT)/wolfcrypt/src/tfm.o\
$(WOLF_ROOT)/wolfcrypt/src/wc_encrypt.o\
$(WOLF_ROOT)/wolfcrypt/src/wc_pkcs11.o\
$(WOLF_ROOT)/wolfcrypt/src/wc_port.o\
$(WOLF_ROOT)/wolfcrypt/src/wolfevent.o\
$(WOLF_ROOT)/wolfcrypt/src/wolfmath.o


all	: wolfssllib client server test benchmark

wolfssllib	: $(OBJ)
	$(AR) r $(WOLFLIB) $(OBJ)
test	: wolfssllib ./user_settings.h
	$(CC) -o test $(CFLAGS) $(WOLF_ROOT)/wolfcrypt/test/test.c $(WOLFLIB) $(MQXLIB)
benchmark	: wolfssllib ./user_settings.h
	$(CC)  -o benchmark $(CFLAGS)  $(WOLF_ROOT)/wolfcrypt/benchmark/benchmark.c $(WOLFLIB) $(WOLFLIB) $(MQXLIB)
server	:  wolfssllib ./user_settings.h
	$(CC)  -o server $(CFLAGS)  $(WOLF_ROOT)/IDE/MQX/server-tls.c $(WOLFLIB) $(MQXLIB)
client  :  wolfssllib ./user_settings.h
	$(CC)  -o client $(CFLAGS) $(WOLF_ROOT)/IDE/MQX/client-tls.c $(WOLFLIB) $(MQXLIB)
clean	: 
	rm $(OBJ) $(WOLFLIB)

=== storage/columnstore/columnstore/tools/configMgt/CMakeLists.txt ===

include_directories( ${ENGINE_COMMON_INCLUDES} )


########### next target ###############

set(autoConfigure_SRCS autoConfigure.cpp)

add_executable(autoConfigure ${autoConfigure_SRCS})

target_link_libraries(autoConfigure ${ENGINE_LDFLAGS} ${NETSNMP_LIBRARIES} ${MARIADB_CLIENT_LIBS} ${ENGINE_EXEC_LIBS})

#install(TARGETS autoConfigure DESTINATION ${ENGINE_BINDIR} COMPONENT columnstore-engine)

=== extra/wolfssl/wolfssl/IDE/QNX/example-cmac/Makefile ===
ARTIFACT = cmac-test

#Build architecture/variant string, possible values: x86, armv7le, etc...
PLATFORM = armv7le
OUTPUT_DIR = build
TARGET = $(ARTIFACT)

CC = qcc -Vgcc_nto$(PLATFORM)
CXX = qcc -lang-c++ -Vgcc_nto$(PLATFORM)
LD = $(CC)

INCLUDES += -I../../../
LIBS += -L../../../src/.libs/ -lwolfssl
LIBS += -lsocket -lm
CCFLAGS += -O2 -Wall

SRCS = cmac-test.c

OBJS = $(addprefix $(OUTPUT_DIR)/,$(addsuffix .o, $(basename $(SRCS))))

$(OUTPUT_DIR)/%.o: %.c
	@mkdir -p $(dir $@)
	$(CC) -c -o $@ $(INCLUDES) $(CCFLAGS) $<

$(TARGET):$(OBJS)
	$(LD) -o $(TARGET) $(OBJS) $(LIBS)

all: $(TARGET)

clean:
	rm -rf $(OUTPUT_DIR) $(ARTIFACT)

rebuild: clean all

=== debian/changelog ===
mariadb-10.6 (1:10.6.7-3ubuntu1) kinetic; urgency=medium

  * d/rules: disable LTO (LP: #1970634)

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 29 Apr 2022 09:30:44 -0300

mariadb-10.6 (1:10.6.7-3) unstable; urgency=medium

  * Fix syntax error in unstable tests lists
  * Forward patches upstream and update metadata for them
  * Bugfix: Include missing sql_parse.cc in ER_KILL_DENIED_ERROR patch
  * Fix mysql_install_db by reverting recent addition (MDEV-27980)
  * Fix htm use on PowerPC to fix build failure (might close #1006527)
  * Revert "Strip path from Mroonga to make the build reproducible"

 -- Otto Kekäläinen <otto@debian.org>  Wed, 09 Mar 2022 22:26:32 -0800

mariadb-10.6 (1:10.6.7-2) unstable; urgency=medium

  * Backport OpenSSL 3.0 support for MariaDB 10.6 series (Closes: #1005950)
  * Clean away most Lintian overrides and unstable-tests to see full
    QA results in Debian experimental
  * Add upstream PR#2028 to fix main.grant_kill test failure
  * Update unstable-tests skip lists after review of 1:10.6.7-2~exp1 builds
  * Fix more spelling errors
  * Fix misc Lintian issues and add overrides

 -- Otto Kekäläinen <otto@debian.org>  Tue, 01 Mar 2022 20:40:07 -0800

mariadb-10.6 (1:10.6.7-1) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * New upstream version 10.6.7. Includes security fixes for
    - CVE-2021-46661
    - CVE-2021-46663
    - CVE-2021-46664
    - CVE-2021-46665
    - CVE-2021-46668
  * New upstream version 10.6.6. Includes security fixes for
    - CVE-2021-46659
    - CVE-2022-24048
    - CVE-2022-24050
    - CVE-2022-24051
    - CVE-2022-24052
  * Previous release 10.6.5 included security fixes for:
    - CVE-2021-46662
    - CVE-2021-46667
  * Notable upstream functional changes in 10.6.6 and 10.6.7:
    - New default value for innodb_change_buffering is 'none' instead of old
      value 'all' (MDEV-27734). This change should improve crash safety but
      might cause performance regressions on systems that use old spinning disks
      (HDD) where seek latency is higher.
    - New default value for innodb_read_only_compressed is 'OFF' instead of
      'ON'. Upstream originally intended to deprecate ROW_FORMAT=COMPRESSED but
      abandoned the plan.
    - New default minimum value for innodb_buffer_pool_size is 20 MB (from 2 MB)
  * Drop MIPS and CTE patches applied now upstream
  * Add upstream patch to make Mroonga builds reproducible (Closes: #976984)
  * Add patch for potential kfreebsd-amd64 build failure (Closes: #994665)
  * Remove useless libaio-dev dependency from d/control (Closes: #1001649)

  [ Faustin Lammler ]
  * Salsa-CI: use a mirror redirector for the CI

  [ Bas Couwenberg ]
  * Don't require debian.cnf to be executable in logrotate (Closes: #1005186)

  [ Tuukka Pasanen ]
  * Remove unneeded path from MariaDB server postinst script

 -- Otto Kekäläinen <otto@debian.org>  Sat, 19 Feb 2022 16:00:00 -0800

=== debian/control ===
Source: mariadb-10.6
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: Otto Kekäläinen <otto@debian.org>
Build-Depends: bison,
               cmake,
               cracklib-runtime <!nocheck>,
               debhelper (>= 10),
               dh-exec,
               gdb <!nocheck>,
               libboost-dev,
               libcrack2-dev (>= 2.9.0),
               libcurl4-openssl-dev | libcurl4-dev,
               libedit-dev,
               libedit-dev:native,
               libjemalloc-dev [linux-any],
               libjudy-dev,
               libkrb5-dev,
               liblz4-dev,
               libncurses5-dev (>= 5.0-6~),
               libncurses5-dev:native (>= 5.0-6~),
               libnuma-dev [linux-any],
               libpam0g-dev,
               libpcre2-dev,
               libpmem-dev [amd64 arm64 ppc64el],
               libsnappy-dev,
               libssl-dev,
               libssl-dev:native,
               libsystemd-dev [linux-any],
               liburing-dev [linux-any],
               libxml2-dev,
               libzstd-dev (>= 1.3.3),
               lsb-release,
               perl:any,
               po-debconf,
               psmisc,
               unixodbc-dev,
               uuid-dev,
               zlib1g-dev (>= 1:1.1.3-5~)
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://mariadb.org/
Vcs-Browser: https://salsa.debian.org/mariadb-team/mariadb-server
Vcs-Git: https://salsa.debian.org/mariadb-team/mariadb-server.git

Package: libmariadb-dev
Architecture: any
Section: libdevel
Depends: libmariadb3 (= ${binary:Version}),
         libssl-dev,
         zlib1g-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libmariadb-client-lgpl-dev,
        libmariadb-dev-compat (<< ${source:Version}),
        libmariadbclient-dev (<< 1:10.3),
        libmysqlclient-dev,
        libmysqld-dev (<< ${source:Version})
Replaces: libmariadb-client-lgpl-dev,
          libmariadb-dev-compat (<< ${source:Version}),
          libmariadbclient-dev (<< 1:10.3),
          libmysqlclient-dev,
          libmysqld-dev (<< ${source:Version})
Conflicts: libmariadbclient16-dev,
           libmysqlclient-dev
Description: MariaDB database development files
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes development libraries and header files. To allow sources
 expecting the MariaDB Connector/C to build. Sources that expect the MySQL
 Client libraries should use files from the libmariadb-dev-compat package.

Package: libmariadb-dev-compat
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libmariadb-dev (= ${binary:Version}),
         ${misc:Depends}
Conflicts: libmariadb-client-lgpl-dev-compat,
           libmariadbclient-dev-compat,
           libmysqlclient-dev
Provides: libmariadb-client-lgpl-dev-compat,
          libmariadbclient-dev-compat
Breaks: libmariadb-client-lgpl-dev-compat,
        libmariadbclient-dev (<< 1:10.3),
        libmariadbclient-dev-compat,
        libmysqlclient-dev
Replaces: libmariadb-client-lgpl-dev-compat,
          libmariadbclient-dev (<< 1:10.3),
          libmariadbclient-dev-compat,
          libmysqlclient-dev
Description: MariaDB Connector/C, compatibility symlinks
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes compatibility symlinks to allow sources expecting the
 MySQL client libraries to be built against MariaDB Connector/C.

Package: libmariadb3
Architecture: any
Multi-Arch: same
Section: libs
Depends: mariadb-common,
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: mariadb-galera-server-10.0,
           mariadb-galera-server-5.5,
           mariadb-server-10.0,
           mariadb-server-5.1,
           mariadb-server-5.2,
           mariadb-server-5.3,
           mariadb-server-5.5
Breaks: libmariadbclient18
Replaces: libmariadbclient18
Description: MariaDB database client library
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the client library.

Package: libmariadbd19
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Multi-Arch: same
Description: MariaDB embedded database, shared library
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes a shared library for embedded MariaDB applications.

Package: libmariadbd-dev
Architecture: any
Section: libdevel
Provides: libmysqld-dev
Pre-Depends: ${misc:Pre-Depends}
Depends: libmariadb-dev (= ${binary:Version}),
         libmariadbd19 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libmariadb-dev (<< 1:10.4),
        libmysqld-dev
Replaces: libmariadb-dev (<< 1:10.4),
          libmysqld-dev
Description: MariaDB embedded database, development files
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the embedded server library development and header files.

Package: mariadb-common
Architecture: all
Depends: mysql-common (>= 5.6.25),
         ${misc:Depends}
Multi-Arch: foreign
Description: MariaDB common configuration files
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes configuration files common to all MariaDB programs.

Package: mariadb-client-core-10.6
Architecture: any
Depends: libmariadb3 (>= 10.5.4),
         mariadb-common (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: mysql-client-5.5,
           mysql-client-5.6,
           mysql-client-5.7,
           mysql-client-8.0,
           virtual-mysql-client-core
Breaks: mariadb-client-10.0,
        mariadb-client-core-10.0,
        mariadb-client-core-10.1,
        mariadb-client-core-10.2,
        mariadb-client-core-10.3,
        mariadb-client-core-10.4,
        mariadb-client-core-10.5,
        mariadb-client-core-5.5,
        mysql-client-core-5.5,
        mysql-client-core-5.6,
        mysql-client-core-5.7,
        mysql-client-core-8.0
Replaces: mariadb-client-10.0,
          mariadb-client-core-10.0,
          mariadb-client-core-10.1,
          mariadb-client-core-10.2,
          mariadb-client-core-10.3,
          mariadb-client-core-10.4,
          mariadb-client-core-10.5,
          mariadb-client-core-5.5,
          mysql-client-core-5.5,
          mysql-client-core-5.6,
          mysql-client-core-5.7,
          mysql-client-core-8.0,
          virtual-mysql-client-core
Provides: virtual-mysql-client-core
Description: MariaDB database core client binaries
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the core client files, as used by Akonadi.

Package: mariadb-client-10.6
Architecture: any
Depends: debianutils (>=1.6),
         libconfig-inifiles-perl,
         mariadb-client-core-10.6 (>= ${source:Version}),
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Conflicts: mysql-client-core-5.5,
           mysql-client-core-5.6,
           mysql-client-core-5.7,
           mysql-client-core-8.0,
           mytop,
           virtual-mysql-client
Breaks: mariadb-client-10.0,
        mariadb-client-10.1,
        mariadb-client-10.2,
        mariadb-client-10.3,
        mariadb-client-10.4,
        mariadb-client-10.5,
        mariadb-client-5.5,
        mariadb-client-core-10.0,
        mariadb-client-core-10.1,
        mariadb-client-core-10.2,
        mariadb-client-core-10.3,
        mariadb-client-core-10.4,
        mariadb-client-core-10.5,
        mariadb-client-core-10.6 (<< ${source:Version}),
        mariadb-server-10.0,
        mysql-client-5.5,
        mysql-client-5.6,
        mysql-client-5.7,
        mysql-client-8.0
Replaces: mariadb-client-10.0,
          mariadb-client-10.1,
          mariadb-client-10.2,
          mariadb-client-10.3,
          mariadb-client-10.4,
          mariadb-client-10.5,
          mariadb-client-5.5,
          mariadb-client-core-10.0,
          mariadb-client-core-10.1,
          mariadb-client-core-10.2,
          mariadb-client-core-10.3,
          mariadb-client-core-10.4,
          mariadb-client-core-10.5,
          mariadb-client-core-10.6 (<< ${source:Version}),
          mariadb-server-10.0,
          mysql-client-5.5,
          mysql-client-5.6,
          mysql-client-5.7,
          mysql-client-8.0,
          mytop,
          virtual-mysql-client
Provides: virtual-mysql-client
Recommends: libdbd-mariadb-perl | libdbd-mysql-perl,
            libdbi-perl,
            libterm-readkey-perl
Description: MariaDB database client binaries
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the client binaries and the additional tools
 innotop and mariadb-report (mysqlreport).

Package: mariadb-server-core-10.6
Architecture: any
Depends: mariadb-common (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: mariadb-galera-server-5.5,
           mysql-server-5.5,
           mysql-server-5.6,
           mysql-server-5.7,
           mysql-server-8.0,
           virtual-mysql-server-core
Breaks: mariadb-client-10.1,
        mariadb-server-10.0,
        mariadb-server-10.1,
        mariadb-server-10.2,
        mariadb-server-10.3,
        mariadb-server-10.4,
        mariadb-server-core-10.0,
        mariadb-server-core-10.1,
        mariadb-server-core-10.2,
        mariadb-server-core-10.3,
        mariadb-server-core-10.4,
        mariadb-server-core-10.5,
        mariadb-server-core-5.5,
        mysql-client-5.5,
        mysql-client-5.6,
        mysql-server-core-5.5,
        mysql-server-core-5.6,
        mysql-server-core-5.7,
        mysql-server-core-8.0,
        percona-server-server-5.6,
        percona-xtradb-cluster-server-5.6,
        percona-xtradb-cluster-server-5.7
Replaces: mariadb-client-10.1,
          mariadb-server-10.0,
          mariadb-server-10.1,
          mariadb-server-10.2,
          mariadb-server-10.3,
          mariadb-server-10.4,
          mariadb-server-10.5,
          mariadb-server-10.6 (<< ${source:Version}),
          mariadb-server-core-10.0,
          mariadb-server-core-10.1,
          mariadb-server-core-10.2,
          mariadb-server-core-10.3,
          mariadb-server-core-10.4,
          mariadb-server-core-10.5,
          mariadb-server-core-5.5,
          mysql-client-5.5,
          mysql-client-5.6,
          mysql-client-5.7,

=== debian/rules ===
#!/usr/bin/make -f

# Enable Debian Hardening
# https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Disable LTO, see LP: #1970634
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

DPKG_EXPORT_BUILDFLAGS = 1
# Include all defaults, including buildflags.mk
include /usr/share/dpkg/default.mk
# CPPFLAGS are nor read by CMake, so copy them to CXXFLAGS
# See why at https://cmake.org/Bug/view.php?id=12928
# This is needed for e.g. all automatic Debian hardening flags to apply on all cmake builds.
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

# Only do a strict symbol checking on Linux
ifneq (,$(filter linux,$(DEB_HOST_ARCH_OS)))
    DPKG_GENSYMBOLS_CHECK_LEVEL := 4
endif

BUILDDIR := builddir
DEB_VERSION_REVISION := $(shell echo $(DEB_VERSION) | sed -e 's/^.*-//')
RELEASE := $(shell lsb_release -r -s) # Use changelog based DEB_DISTRIBUTION instead?
TMP:=$(CURDIR)/debian/tmp

# According to Debian Policy version 4.2.0 builds should be as verbose as
# possible unless 'terse' is specifically passed.
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
    export DH_VERBOSE=1
endif

# Parallel build support as advised
# at https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
else
    # NUMJOBS cannot be empty as it is used as a parameter to mtr, default to 'auto'.
    NUMJOBS = auto
endif

# RocksDB cannot build on 32-bit platforms
ifeq (32,$(DEB_HOST_ARCH_BITS))
    CMAKEFLAGS += -DPLUGIN_ROCKSDB=NO
endif

# Cross building requires stack direction instruction
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
    ifneq (,$(filter $(DEB_HOST_ARCH_CPU),alpha amd64 arm arm64 i386 ia64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64))
        CMAKEFLAGS += -DSTACK_DIRECTION=-1
    endif
    ifneq (,$(filter $(DEB_HOST_ARCH_CPU),hppa))
        CMAKEFLAGS += -DSTACK_DIRECTION=1
    endif
endif

# Only attempt to build with PMEM on archs that have package libpmem-dev available
# See https://packages.debian.org/search?searchon=names&keywords=libpmem-dev
ifneq (,$(filter $(DEB_HOST_ARCH_CPU),amd64 arm64 ppc64el))
		CMAKEFLAGS += -DWITH_PMEM=yes
endif

# Add support for verbose builds
MAKEFLAGS += VERBOSE=1

override_dh_auto_clean:
	@echo "RULES.$@"
	dh_testdir
	dh_testroot
	# Delete obsolete/unstable components to ensure they are not used in Debian
	rm -rf $(BUILDDIR) builddir-native extra/readline extra/wolfssl
	# Remove columnstore as the source code is dirty and software not mature enough for Debian anyway
	rm -rf storage/columnstore
	# Delete precompiled binaries in upstream sources to ensure they are not used in Debian
	rm -rf storage/connect/JavaWrappers.jar	storage/columnstore/columnstore/utils/jemalloc/libjemalloc.so.2

	debconf-updatepo # Update po-files when clean runs before each build

override_dh_auto_configure:
	@echo "RULES.$@"
	dh_testdir

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	dpkg-architecture -a$(DEB_BUILD_ARCH) -f -c dh_auto_configure --builddirectory=builddir-native
	dh_auto_build --builddirectory=builddir-native -- import_executables
endif

	echo "server:Version=$(DEB_VERSION)" >> debian/substvars

	# Don't build ColumnStore, not mature enough for Debian yet.
	PATH=$${MYSQL_BUILD_PATH:-"/usr/lib/ccache:/usr/local/bin:/usr/bin:/bin"} \
	    dh_auto_configure --builddirectory=$(BUILDDIR) -- \
	    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	    $(CMAKEFLAGS) \
	    $(if $(filter $(DEB_BUILD_ARCH),$(DEB_HOST_ARCH)),,-DIMPORT_EXECUTABLES=$(CURDIR)/builddir-native/import_executables.cmake) \
	    -DCOMPILATION_COMMENT="$(DEB_VENDOR) $(RELEASE)" \
	    -DMYSQL_SERVER_SUFFIX="-$(DEB_VERSION_REVISION)" \
	    -DSYSTEM_TYPE="debian-$(DEB_HOST_GNU_SYSTEM)" \
	    -DCMAKE_SYSTEM_PROCESSOR=$(DEB_HOST_ARCH) \
	    -DBUILD_CONFIG=mysql_release \
	    -DCONC_DEFAULT_CHARSET=utf8mb4 \
	    -DPLUGIN_AWS_KEY_MANAGEMENT=NO \
	    -DPLUGIN_COLUMNSTORE=NO \
			-DWITH_NUMA=auto \
	    -DIGNORE_AIO_CHECK=YES \
	    -DWITH_URING=YES \
	    -DWITH_INNODB_SNAPPY=ON \
	    -DDEB=$(DEB_VENDOR)

# This is needed, otherwise 'make test' will run before binaries have been built
override_dh_auto_build:
	@echo "RULES.$@"
	# Print build env info to help debug builds on different platforms
	dpkg-architecture
	cd $(BUILDDIR) && $(MAKE)

override_dh_auto_test:
	@echo "RULES.$@"
	dh_testdir
	# Ensure at least an empty file exists
	touch mysql-test/unstable-tests
	# Skip unstable tests if such are defined for arch
	[ ! -f debian/unstable-tests.$(DEB_HOST_ARCH) ] || cat debian/unstable-tests.$(DEB_HOST_ARCH) >> mysql-test/unstable-tests
	# Run testsuite
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Don't use --mem here as official Debian builders and most Docker systems don't have a large mem device available and
	# would fail with errors on lack of disk space.
	cd $(BUILDDIR)/mysql-test && \
	./mtr --force --testcase-timeout=120 --suite-timeout=540 --retry=3 \
	      --parallel=$(NUMJOBS) --skip-rpl --suite=main \
	      --skip-test-list=unstable-tests
endif

override_dh_auto_install:
	@echo "RULES.$@"
	dh_testdir
	dh_testroot

ifneq (,$(filter linux,$(DEB_HOST_ARCH_OS)))
	# Copy systemd files to a location available for dh_installinit
	cp $(BUILDDIR)/support-files/mariadb.service debian/mariadb-server-10.6.mariadb.service
	cp $(BUILDDIR)/support-files/mariadb.socket debian/mariadb-server-10.6.mariadb.socket
	cp $(BUILDDIR)/support-files/mariadb-extra.socket debian/mariadb-server-10.6.mariadb-extra.socket
	cp $(BUILDDIR)/support-files/mariadb@.service debian/mariadb-server-10.6.mariadb@.service
	cp $(BUILDDIR)/support-files/mariadb@.socket debian/mariadb-server-10.6.mariadb@.socket
	cp $(BUILDDIR)/support-files/mariadb-extra@.socket debian/mariadb-server-10.6.mariadb-extra@.socket
endif

	# Run 'make install' without output since it is uninteresting and
	# silencing it helps to make overall build log shorter and more readable
	@echo "Running $(MAKE) install DESTDIR=$(TMP) ..."
	cd $(BUILDDIR) && $(MAKE) install DESTDIR=$(TMP) > /dev/null

	# If mariadb-test package is removed, also remove most of it's files
	grep --quiet "Package: mariadb-test" debian/control || rm -rf $(TMP)/usr/share/mysql/mysql-test

	# Delete private files from libraries so they don't get shipped in the -dev packages
	rm -r $(TMP)/usr/include/mariadb/server/private

	# Don't ship sql-bench at all, just delete it completely even though it builds
	rm -r $(TMP)/usr/sql-bench

	# nm numeric soft is not enough, therefore extra sort in command
	# to satisfy Debian reproducible build requirements
	nm --defined-only $(BUILDDIR)/sql/mariadbd | LC_ALL=C sort | gzip -n -9 > $(TMP)/usr/share/doc/mariadb-server-10.6/mariadbd.sym.gz

	# Rename and install AppArmor profile
	install -D -m 644 debian/apparmor-profile $(TMP)/etc/apparmor.d/usr.sbin.mariadbd

	# Install mariadb.pc as a symlink for the client library,
	# use -f to override the existing server mariadb.pc file
	ln -sf libmariadb.pc $(TMP)/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/mariadb.pc

	# Install libmariadbclient18 compatibility links
	ln -s libmariadb.so.3 $(TMP)/usr/lib/$(DEB_HOST_MULTIARCH)/libmariadbclient.so

	# Install libmariadbclient.a compatibility link
	ln -s libmariadb.a $(TMP)/usr/lib/$(DEB_HOST_MULTIARCH)/libmariadbclient.a

	# Symlink plugins that are used by both server and client and thus need to
	# load from the libmariadb path as well
	ln -s ../../../mysql/plugin/auth_test_plugin.so $(TMP)/usr/lib/$(DEB_HOST_MULTIARCH)/libmariadb3/plugin/auth_test_plugin.so
	ln -s ../../../mysql/plugin/qa_auth_interface.so $(TMP)/usr/lib/$(DEB_HOST_MULTIARCH)/libmariadb3/plugin/qa_auth_interface.so
	ln -s ../../../mysql/plugin/test_sql_service.so $(TMP)/usr/lib/$(DEB_HOST_MULTIARCH)/libmariadb3/plugin/test_sql_service.so
	# Move test plugins that are only needed by the client to the libmariadb path
